#
# Conditional build:
%bcond_without	apidocs		# API documentation
%bcond_without	luajit		# LuaJIT implementation of lua 5.1
%bcond_without	static_libs	# static libraries
%bcond_without	glade		# glade catalog file packaging
%bcond_without	lua		# Lua (5.1) loader
%bcond_without	python2		# Python 2.x loader
%bcond_without	python3		# Python 3.x loader

# luajit is not supported on x32
%ifarch x32
%undefine	with_luajit
%endif

Summary:	GObject Plugin System
Summary(pl.UTF-8):	System wtyczek GObject
Name:		libpeas
Version:	1.36.0
Release:	5
License:	LGPL v2.1+
Group:		Libraries
Source0:	https://download.gnome.org/sources/libpeas/1.36/%{name}-%{version}.tar.xz
# Source0-md5:	b3dd31a79c47af0cbf22f2d6bf52bc7d
URL:		https://wiki.gnome.org/Libpeas
BuildRequires:	gettext-tools >= 0.19.7
%{?with_apidocs:BuildRequires:	gi-docgen >= 2021.7}
%{?with_glade:BuildRequires:	glade-devel >= 2.0}
BuildRequires:	glib2-devel >= 1:2.44.0
BuildRequires:	gobject-introspection-devel >= 1.40.0
BuildRequires:	gtk+3-devel >= 3.0.0
%if %{with lua}
BuildRequires:	lua-lgi >= 0.9.0
%if %{without luajit}
BuildRequires:	lua51 >= 5.1.0
BuildRequires:	lua51-devel >= 5.1.0
%else
BuildRequires:	luajit >= 2.0
BuildRequires:	luajit-devel >= 2.0
%endif
%endif
BuildRequires:	meson >= 0.50.0
BuildRequires:	ninja >= 1.5
BuildRequires:	pkgconfig
%if %{with python2}
BuildRequires:	python-devel >= 1:2.5.2
BuildRequires:	python-pygobject3-devel >= 3.2.0
%endif
%if %{with python3}
BuildRequires:	python3-devel >= 1:3.2.0
BuildRequires:	python3-pygobject3-devel >= 3.2.0
%endif
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 2.042
BuildRequires:	tar >= 1:1.22
BuildRequires:	vala
BuildRequires:	xz
%{!?with_luajit:BuildConflicts:	luajit-devel}
Requires:	glib2 >= 1:2.44.0
Requires:	gobject-introspection >= 1.40.0
Obsoletes:	libpeas-loader-gjs < 1.10.0
Obsoletes:	libpeas-loader-seed < 1.14.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
libpeas is a gobject-based plugins engine, and is targetted at giving
every application the chance to assume its own extensibility. It also
has a set of features including, but not limited to:
 - multiple extension points
 - on demand (lazy) programming language support for C, Python and Lua
 - simplicity of the API

%description -l pl.UTF-8
libpeas to silnik wtyczek oparty na bibliotece GObject; jego celem
jest zapewnienie każdej aplikacji własnej rozszerzalności. Ma także
pewien zbiór możliwości, w tym:
 - wiele punktów rozszerzeń
 - wsparcie dla leniwego programowania dla języków C, Python i Lua
 - prostota API

%package loader-lua
Summary:	Lua loader for libpeas library
Summary(pl.UTF-8):	Moduł ładujący dla języka Lua do biblioteki libpeas
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	lua-lgi >= 0.9.0

%description loader-lua
Lua loader for libpeas library.

%description loader-lua -l pl.UTF-8
Moduł ładujący dla języka Lua do biblioteki libpeas.

%package loader-python
Summary:	Python 2.x loader for libpeas library
Summary(pl.UTF-8):	Moduł ładujący dla Pythona 2.x do biblioteki libpeas
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	python-libs >= 1:2.5.2

%description loader-python
Python 2.x loader for libpeas library.

%description loader-python -l pl.UTF-8
Moduł ładujący dla Pythona 2.x do biblioteki libpeas.

%package loader-python3
Summary:	Python 3.x loader for libpeas library
Summary(pl.UTF-8):	Moduł ładujący dla Pythona 3.x do biblioteki libpeas
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description loader-python3
Python 3.x loader for libpeas library.

%description loader-python3 -l pl.UTF-8
Moduł ładujący dla Pythona 3.x do biblioteki libpeas.

%package devel
Summary:	Header files for libpeas library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libpeas
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	glib2-devel >= 1:2.44.0
Requires:	gobject-introspection-devel >= 1.40.0

%description devel
Header files for libpeas library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libpeas.

%package static
Summary:	Static libpeas library
Summary(pl.UTF-8):	Statyczna biblioteka libpeas
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libpeas library.

%description static -l pl.UTF-8
Statyczna biblioteka libpeas.

%package gtk
Summary:	GObject Plugin System - GTK+ widgets
Summary(pl.UTF-8):	System wtyczek GObject - widgety GTK+
Group:		X11/Libraries
Requires(post,postun):	gtk-update-icon-cache
Requires:	%{name} = %{version}-%{release}
Requires:	gtk+3 >= 3.0.0
Requires:	hicolor-icon-theme

%description gtk
libpeas is a gobject-based plugins engine, and is targetted at giving
every application the chance to assume its own extensibility. It also
has a set of features including, but not limited to:
 - multiple extension points
 - on demand (lazy) programming language support for C, Python and Lua
 - simplicity of the API

This package contains GTK+ widgets library.

%description gtk -l pl.UTF-8
libpeas to silnik wtyczek oparty na bibliotece GObject; jego celem
jest zapewnienie każdej aplikacji własnej rozszerzalności. Ma także
pewien zbiór możliwości, w tym:
 - wiele punktów rozszerzeń
 - wsparcie dla leniwego programowania dla języków C, Python i Lua
 - prostota API

Ten pakiet zawiera bibliotekę widgetów GTK+.

%package gtk-devel
Summary:	Header files for libpeas-gtk library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libpeas-gtk
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-gtk = %{version}-%{release}
Requires:	gtk+3-devel >= 3.0.0

%description gtk-devel
Header files for libpeas-gtk library.

%description gtk-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libpeas-gtk.

%package gtk-glade
Summary:	libpeas-gtk catalog file for Glade
Summary(pl.UTF-8):	Plik katalogu libpeas-gtk dla Glade
Group:		X11/Development/Libraries
Requires:	%{name}-gtk-devel = %{version}-%{release}
Requires:	glade >= 2.0

%description gtk-glade
libpeas-gtk catalog file for Glade.

%description gtk-glade -l pl.UTF-8
Plik katalogu libpeas-gtk dla Glade.

%package gtk-static
Summary:	Static libpeas-gtk library
Summary(pl.UTF-8):	Statyczna biblioteka libpeas-gtk
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-gtk-devel = %{version}-%{release}

%description gtk-static
Static libpeas library.

%description gtk-static -l pl.UTF-8
Statyczna biblioteka libpeas.

%package apidocs
Summary:	libpeas API documentation
Summary(pl.UTF-8):	Dokumentacja API biblioteki libpeas
Group:		Documentation
BuildArch:	noarch

%description apidocs
API and internal documentation for libpeas library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki libpeas.

%package demo
Summary:	Demo application for libpeas
Summary(pl.UTF-8):	Aplikacja demonstracyjna libpeas
Group:		Applications
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-gtk = %{version}-%{release}
%if %{with lua}
Requires:	%{name}-loader-lua = %{version}-%{release}
%endif
%if %{with python3}
Requires:	%{name}-loader-python3 = %{version}-%{release}
%endif

%description demo
Demo application for libpeas.

%description demo -l pl.UTF-8
Aplikacja demonstracyjna libpeas.

%prep
%setup -q

%if %{with lua}
# meson buildsystem expects .pc file for lua-lgi detection
install -d fake-pkgconfig
cat >fake-pkgconfig/lua5.1-lgi.pc <<'EOF'
Name: lua-lgi
Description: Lua LGI
Version: %(rpm -q --qf '%%{V}\n' lua-lgi)
EOF
%endif

%build
export PKG_CONFIG_PATH=$(pwd)/fake-pkgconfig
%meson \
	%{!?with_static_libs:--default-library=shared} \
	%{!?with_glade:-Dglade_catalog=false} \
	%{?with_apidocs:-Dgtk_doc=true} \
	%{!?with_lua:-Dlua51=false} \
	%{?with_python2:-Dpython2=true} \
	%{!?with_python3:-Dpython3=false} \
	-Dvapi=true

%meson_build

%install
rm -rf $RPM_BUILD_ROOT

%meson_install

%py3_comp $RPM_BUILD_ROOT%{_libdir}/peas-demo/plugins/pythonhello
%py3_ocomp $RPM_BUILD_ROOT%{_libdir}/peas-demo/plugins/pythonhello

%if %{with apidocs}
install -d $RPM_BUILD_ROOT%{_gidocdir}
%{__mv} $RPM_BUILD_ROOT%{_datadir}/doc/libpeas-* $RPM_BUILD_ROOT%{_gidocdir}
%endif

# not supported by glibc (as of 2.37)
%{__rm} -r $RPM_BUILD_ROOT%{_localedir}/ie

%find_lang libpeas-1.0

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post gtk
/sbin/ldconfig
%update_icon_cache hicolor

%postun	gtk
/sbin/ldconfig
%update_icon_cache hicolor

%files -f libpeas-1.0.lang
%defattr(644,root,root,755)
%doc AUTHORS NEWS README
%attr(755,root,root) %{_libdir}/libpeas-1.0.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpeas-1.0.so.0
%dir %{_libdir}/libpeas-1.0
%dir %{_libdir}/libpeas-1.0/loaders
%{_libdir}/girepository-1.0/Peas-1.0.typelib

%if %{with lua}
%files loader-lua
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpeas-1.0/loaders/liblua51loader.so
%endif

%if %{with python2}
%files loader-python
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpeas-1.0/loaders/libpythonloader.so
%endif

%if %{with python3}
%files loader-python3
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpeas-1.0/loaders/libpython3loader.so
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpeas-1.0.so
%{_includedir}/libpeas-1.0
%{_pkgconfigdir}/libpeas-1.0.pc
%{_datadir}/gir-1.0/Peas-1.0.gir

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libpeas-1.0.a
%endif

%files gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpeas-gtk-1.0.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpeas-gtk-1.0.so.0
%{_libdir}/girepository-1.0/PeasGtk-1.0.typelib
%{_iconsdir}/hicolor/*x*/actions/libpeas-plugin.png
%{_iconsdir}/hicolor/scalable/actions/libpeas-plugin.svg

%files gtk-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpeas-gtk-1.0.so
%{_pkgconfigdir}/libpeas-gtk-1.0.pc
%{_datadir}/gir-1.0/PeasGtk-1.0.gir

%if %{with glade}
%files gtk-glade
%defattr(644,root,root,755)
%{_datadir}/glade/catalogs/libpeas-gtk.xml
%endif

%if %{with static_libs}
%files gtk-static
%defattr(644,root,root,755)
%{_libdir}/libpeas-gtk-1.0.a
%endif

%files demo
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/peas-demo
%dir %{_libdir}/peas-demo
%dir %{_libdir}/peas-demo/plugins
%dir %{_libdir}/peas-demo/plugins/helloworld
%attr(755,root,root) %{_libdir}/peas-demo/plugins/helloworld/libhelloworld.so
%{_libdir}/peas-demo/plugins/helloworld/helloworld.plugin
%if %{with lua}
%dir %{_libdir}/peas-demo/plugins/luahello
%{_libdir}/peas-demo/plugins/luahello/luahello.lua
%{_libdir}/peas-demo/plugins/luahello/luahello.plugin
%endif
%if %{with python3}
%dir %{_libdir}/peas-demo/plugins/pythonhello
%{_libdir}/peas-demo/plugins/pythonhello/pythonhello.plugin
%{_libdir}/peas-demo/plugins/pythonhello/pythonhello.py
%{_libdir}/peas-demo/plugins/pythonhello/__pycache__
%endif
%dir %{_libdir}/peas-demo/plugins/secondtime
%attr(755,root,root) %{_libdir}/peas-demo/plugins/secondtime/libsecondtime.so
%{_libdir}/peas-demo/plugins/secondtime/secondtime.plugin

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%{_gidocdir}/libpeas-1.0
%{_gidocdir}/libpeas-gtk-1.0
%endif
%changelog
* Thu Mar 20 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libpeas.git;a=log;h=master

* Thu Mar 20 2025 Jan Palus <atler@pld-linux.org> daf6fd1
- Release 5 (by relup.sh)

* Thu Mar 20 2025 Jan Palus <atler@pld-linux.org> 4f2a371
- BR: pkgconfig

* Thu Mar 20 2025 Jan Palus <atler@pld-linux.org> faaf25b
- use new meson macros

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> f020bab
- Release 4 (by relup.sh)

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 170cd3f
- python 3.13 rebuild

* Wed Sep 27 2023 Jakub Bogusz <qboosh@pld-linux.org> 205dbfc
- use _gidocdir for apidocs

* Fri Mar 24 2023 Jakub Bogusz <qboosh@pld-linux.org> 38d22cb
- drop ie locale; release 2

* Thu Mar 23 2023 Jakub Bogusz <qboosh@pld-linux.org> c2d71da
- updated to 1.36.0

* Fri Sep 30 2022 Jan Palus <atler@pld-linux.org> 8752be3
- lua detection mechanism needs interpreter binary as well

* Wed Sep 28 2022 Jakub Bogusz <qboosh@pld-linux.org> ae58e09
- updated to 1.34.0

* Tue Mar 29 2022 Jan Palus <atler@pld-linux.org> b4f1d18
- up to 1.32.0

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 3622c2b
- rebuild with python 3.10

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> d70a113
- rebuild with separate debuginfo build-ids

* Mon Mar 22 2021 Jakub Bogusz <qboosh@pld-linux.org> 4c8b34c
- updated meson and rpm versions

* Sun Mar 21 2021 Jan Palus <atler@pld-linux.org> 8bc1ec7
- up to 1.30.0

* Sun Feb 28 2021 Jan Palus <atler@pld-linux.org> 51b4640
- release 2 (by relup.sh)

* Sun Feb 28 2021 Jan Palus <atler@pld-linux.org> 1b9af4f
- rediff patch

* Sun Feb 28 2021 Jan Palus <atler@pld-linux.org> 7f46125
- updated source url

* Sun Feb 28 2021 Jan Palus <atler@pld-linux.org> 90d547c
- unconditional noarch subpackage

* Sun Sep 13 2020 Jakub Bogusz <qboosh@pld-linux.org> 0a2950c
- updated to 1.28.0

